Attribute VB_Name = "modDatabaseHandling"
Option Explicit

Public app_dir_databases As String

Public app_file_will As String
Public app_file_wont As String
Public app_file_do As String
Public app_file_dont As String

Public Sub InitializeDirectories()
    Call ChangeStatusBar("Initialize Directories...")

    app_dir_databases = App.Path & "\database\"
    
    Call ChangeStatusBarDone
End Sub

Public Sub InitializeFiles()
    Call ChangeStatusBar("Initialize Files...")
    
    Const sExtension As String = ".fdb"

    app_file_will = "will" & sExtension
    app_file_wont = "wont" & sExtension
    app_file_do = "do" & sExtension
    app_file_dont = "dont" & sExtension
    
    Call ChangeStatusBarDone
End Sub

Public Sub SaveAllFingerprintsToDatabase(ByRef sImplementationName As String, ByRef sDatabasePath As String)
    Call ChangeStatusBar("Save All Fingerprints to Database...")
    
    Call SaveFingerprintsToDatabase(sImplementationName, sDatabasePath & app_file_will, fingerprint_will)
    Call SaveFingerprintsToDatabase(sImplementationName, sDatabasePath & app_file_wont, fingerprint_wont)
    Call SaveFingerprintsToDatabase(sImplementationName, sDatabasePath & app_file_do, fingerprint_do)
    Call SaveFingerprintsToDatabase(sImplementationName, sDatabasePath & app_file_dont, fingerprint_dont)

    Call SaveNewFingerprintToDatabase(sDatabasePath & "fingerprints.fdb", sImplementationName, fingerprint_full)

    Call ChangeStatusBarDone
End Sub

Public Sub SaveFingerprintsToDatabase(ByRef sImplementationName As String, ByRef sFingerprintPath As String, ByRef sFingerprintList As String)
    Dim sFingerprintElements() As String
    Dim iFingerprintElementsCount As String
    Dim i As Integer
    
    sFingerprintElements = Split(sFingerprintList, ";", , vbBinaryCompare)
    iFingerprintElementsCount = UBound(sFingerprintElements)
    
    For i = 0 To iFingerprintElementsCount
        Call SaveNewFingerprintToDatabase(sFingerprintPath, sImplementationName, sFingerprintElements(i))
    Next i
End Sub

Public Sub SaveNewFingerprintToDatabase(ByRef sFileName As String, ByRef sImplementationName As String, ByRef sFingerprintValue As String)
    Dim sNewEntry As String
    
    If (Dir$(sFileName, 16) <> "") Then
        If (LenB(sFingerprintValue)) Then
            If (LenB(sImplementationName)) Then
                sNewEntry = sImplementationName & ";" & sFingerprintValue
                If (IsAlreadyInDatabase(sFileName, sNewEntry) = False) Then
                    Open sFileName For Append As #1
                        Print #1, sNewEntry
                    Close
                End If
            End If
        End If
    End If
End Sub

Public Function IsAlreadyInDatabase(ByRef sDatabase As String, ByRef sNewEntry As String) As Boolean
    Dim sDatabaseContent As String
    
    sDatabaseContent = ReadFile(sDatabase)
    
    If (InStrB(1, sDatabaseContent, sNewEntry, vbBinaryCompare)) Then
        IsAlreadyInDatabase = True
    Else
        IsAlreadyInDatabase = False
    End If
End Function

Public Function ReadFile(ByRef sFileName As String) As String
    Dim sFileContent As String
    
    If (Dir$(sFileName, 16) <> "") Then
        Open sFileName For Input As #1
            sFileContent = Input(LOF(1), #1)
        Close
    End If
    
    ReadFile = sFileContent
End Function

Public Sub SaveFingerprints(ByRef sImplementationName As String)
    If (LenB(sImplementationName)) Then
        Call SaveAllFingerprintsToDatabase(sImplementationName, app_dir_databases)
        Call AnalyzeFingerprintsAndShowResult
    End If
End Sub
